unit u_handnet;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Menus, ExtCtrls;

type
  TForm1 = class(TForm)
    menu: TMainMenu; Datei1: TMenuItem; Beenden1: TMenuItem;
    gb_einst: TGroupBox; l_zeitf: TLabel; zeitfortschritt: TEdit;
    l_einheit1: TLabel; l_pegelh: TLabel; pegel: TEdit;
    l_einheit2: TLabel; l_baudr: TLabel;
    baudrate: TEdit; l_einheit3: TLabel; l_bitl: TLabel;
    bitlaenge: TLabel; l_einheit4: TLabel; b_start: TButton;
    Timer: TTimer;
    anaus: TButton;
    procedure baudrateChange(Sender: TObject);
    procedure b_startClick(Sender: TObject);
    procedure TimerTimer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure anausMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure anausMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Beenden1Click(Sender: TObject);
    procedure anausKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure anausKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    buffer : TBitmap;
    pos : integer;
    strom : integer;
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.baudrateChange(Sender: TObject);
var
  a : set of char;
  i,k : integer;
  hs : string;
  b : boolean;
  no : real;
begin
  a := ['1','2','3','4','5','6','7','8','9','0',','];
  b := true; k := 0; hs := baudrate.Text;
  for i := 1 to Length(hs) do
    if (hs[i] = ',')  then k := k+1;
  for i := 1 to Length(hs) do
    if not (hs[i] in a) then b := false;
  if Length(hs)<1 then b := false;
  if k > 1 then b := false;
  if b then
    if StrToFloat(hs) <> 0 then
      no := 1/StrToFloat(hs)
    else no := 0;
  bitlaenge.Caption := FloatToStrF(no,ffFixed,5,3);
end;

procedure TForm1.b_startClick(Sender: TObject);
var
  i : integer;
begin
  if b_start.Caption = 'Stop' then
  begin
    Timer.Enabled := false;
    b_start.Caption := 'Start';
    baudrate.Enabled := true;
    pegel.Enabled := true;
    zeitfortschritt.Enabled := true;
  end
  else
  begin
    Timer.Interval := round(StrToFloat(bitlaenge.Caption)*1000/StrToInt(zeitfortschritt.Text));
    Timer.Enabled := true;
    b_start.Caption := 'Stop';
    baudrate.Enabled := false;
    pegel.Enabled := false;
    zeitfortschritt.Enabled := false;
    buffer.Width := Width;
    buffer.Height := StrToInt(pegel.Text)+12;
    pos := 0;
  buffer.Canvas.FillRect(Rect(0,0,buffer.Width,buffer.Height));
  //buffer.Canvas.Font.Size := 24;
  buffer.Canvas.TextOut(0,0,'1');
  buffer.Canvas.TextOut(0,buffer.Height-buffer.Canvas.TextHeight('0'),'0');
  buffer.Canvas.Pen.Style := psDot;
  buffer.Canvas.Pen.Color := clSilver;
  for i := 0 to buffer.Width-10 div StrToInt(zeitfortschritt.Text) do
  begin
    buffer.Canvas.MoveTo(i*StrToInt(zeitfortschritt.Text)+buffer.Canvas.TextWidth('0')+1,0);
    buffer.Canvas.LineTo(i*StrToInt(zeitfortschritt.Text)+buffer.Canvas.TextWidth('0')+1,buffer.Height);
  end;
  buffer.Canvas.Pen.Style := psSolid;
  buffer.Canvas.MoveTo(buffer.Canvas.TextWidth('0')+1,buffer.Canvas.TextHeight('1') div 2);
  buffer.Canvas.LineTo(buffer.Width,buffer.Canvas.TextHeight('1') div 2);
  buffer.Canvas.MoveTo(buffer.Canvas.TextWidth('0')+1,buffer.Height-buffer.Canvas.TextHeight('0') div 2 -1);
  buffer.Canvas.LineTo(buffer.Width,buffer.Height-buffer.Canvas.TextHeight('0') div 2 -1);
  buffer.Canvas.Pen.Color := clred;
  buffer.Canvas.MoveTo(pos+buffer.Canvas.TextWidth('0')+1,strom*(buffer.Height-buffer.Canvas.TextHeight('0'))+buffer.Canvas.TextHeight('0') div 2);
  end;
end;

procedure TForm1.TimerTimer(Sender: TObject);
begin
  buffer.Canvas.LineTo(pos+buffer.Canvas.TextWidth('0'),strom*(buffer.Height-buffer.Canvas.TextHeight('0'))+buffer.Canvas.TextHeight('0') div 2);
  buffer.Canvas.LineTo(pos+buffer.Canvas.TextWidth('0')+1,strom*(buffer.Height-buffer.Canvas.TextHeight('0'))+buffer.Canvas.TextHeight('0') div 2);
  inc(pos);
  Canvas.Draw(1,b_start.Top+b_start.Height+1,buffer);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  buffer := TBitmap.Create;
  strom := 0;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  buffer.Free;
end;

procedure TForm1.anausMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  strom := 1;
end;

procedure TForm1.anausMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  Strom := 0;
end;

procedure TForm1.Beenden1Click(Sender: TObject);
begin
  halt;
end;

procedure TForm1.anausKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  strom := 1;
end;

procedure TForm1.anausKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  Strom := 0;
end;

end.
